BCL mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 ] 1.0.5000.0 2.0.0.0 4.0.0.0 All public static members of this type are safe for multithreaded operations. No instance members are guaranteed to be thread safe. System.SystemException System.Runtime.InteropServices.ComVisible(true)

The following example demonstrates an error that causes a exception.

`using System; using System.Collections; public class InvalidOpExample { public static void Main() { int[] array = {0,0}; IEnumerator enumerator = array.GetEnumerator(); Console.Write("{0}",enumerator.Current); } }`

The output is

Unhandled Exception: System.InvalidOperationException: Enumeration has not started. Call MoveNext.

at System.SZArrayEnumerator.get_Current()

at InvalidOpExample.Main()

is used in cases when the failure to invoke a method is caused by reasons other than invalid arguments. For example, is thrown by:

if objects of a collection are modified after the enumerator is created.

if the resource set is closed before the method call is made.

To determine the precise cause of the exception, consult the exception information for the method call that throws the exception.

If the method invocation failure is due to invalid arguments, then or one of its derived classes, or , should be thrown instead.

The Microsoft intermediate language (MSIL) instruction throws .

uses the HRESULT COR_E_INVALIDOPERATION, which has the value 0x80131509.

For a list of initial property values for an instance of , see the constructors.

The exception that is thrown when a method call is invalid for the object's current state.

- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  This constructor initializes the property of the new instance to a system-supplied message that describes the error, such as "The requested operation cannot be performed." This message takes into account the current system culture.

  The following table shows the initial property values for an instance of .

  Property

  Value

  A null reference (Nothing in Visual Basic).

  The localized error message string.

  Initializes a new instance of the class.

  0
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  This constructor initializes the property of the new exception using the parameter. The content of is intended to be understood by humans. The caller of this constructor is required to ensure that this string has been localized for the current system culture.

  The following table shows the initial property values for an instance of .

  Property

  Value

  A null reference (Nothing in Visual Basic).

  The error message string.

  Initializes a new instance of the class with a specified error message.

  The message that describes the error.
  0
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  This constructor is called during deserialization to reconstitute the exception object transmitted over a stream. For more information, see [<topic://cpconSerialization>].

  Initializes a new instance of the class with serialized data.

  The object that holds the serialized object data.
  The contextual information about the source or destination.
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  An exception that is thrown as a direct result of a previous exception should include a reference to the previous exception in the property. The property returns the same value that is passed into the constructor, or a null reference (Nothing in Visual Basic) if the property does not supply the inner exception value to the constructor.

  The following table shows the initial property values for an instance of .

  Property

  Value

  The inner exception reference.

  The error message string.

  Initializes a new instance of the class with a specified error message and a reference to the inner exception that is the cause of this exception.

  The error message that explains the reason for the exception.
  The exception that is the cause of the current exception. If the parameter is not a null reference (Nothing in Visual Basic), the current exception is raised in a catch block that handles the inner exception.
  0
0